// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.1
// Generated from file `C:\projects\IceAssertion\Simple.ice'

using _System = System;
using _Microsoft = Microsoft;

namespace Demo
{
    public interface Simple : Ice.Object, _SimpleOperations, _SimpleOperationsNC
    {
    }
}

namespace Demo
{
    public interface SimplePrx : Ice.ObjectPrx
    {
	void SomeOperations();
	void SomeOperations(Ice.Context __context);
    }
}

namespace Demo
{
    public interface _SimpleOperations
    {
	void SomeOperations(Ice.Current __current);
    }

    public interface _SimpleOperationsNC
    {
	void SomeOperations();
    }
}

namespace Demo
{
    public sealed class SimplePrxHelper : Ice.ObjectPrxHelperBase, SimplePrx
    {
	#region Synchronous operations

	public void SomeOperations()
	{
	    SomeOperations(__defaultContext());
	}

	public void SomeOperations(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    Ice._ObjectDel __delBase = __getDelegate();
		    _SimpleDel __del = (_SimpleDel)__delBase;
		    __del.SomeOperations(__context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	#endregion

	#region Checked and unchecked cast operations

	public static SimplePrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is SimplePrx)
	    {
		return (SimplePrx)b;
	    }
	    if(b.ice_isA("::Demo::Simple"))
	    {
		SimplePrxHelper h = new SimplePrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static SimplePrx checkedCast(Ice.ObjectPrx b, Ice.Context ctx)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is SimplePrx)
	    {
		return (SimplePrx)b;
	    }
	    if(b.ice_isA("::Demo::Simple", ctx))
	    {
		SimplePrxHelper h = new SimplePrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static SimplePrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::Demo::Simple"))
		{
		    SimplePrxHelper h = new SimplePrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static SimplePrx checkedCast(Ice.ObjectPrx b, string f, Ice.Context ctx)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::Demo::Simple", ctx))
		{
		    SimplePrxHelper h = new SimplePrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static SimplePrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    SimplePrxHelper h = new SimplePrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static SimplePrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    SimplePrxHelper h = new SimplePrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _SimpleDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _SimpleDelD();
	}

	public static void __write(IceInternal.BasicStream __os, SimplePrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static SimplePrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		SimplePrxHelper result = new SimplePrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }
}

namespace Demo
{
    public interface _SimpleDel : Ice._ObjectDel
    {
	void SomeOperations(Ice.Context __context);
    }
}

namespace Demo
{
    public sealed class _SimpleDelM : Ice._ObjectDelM, _SimpleDel
    {
	public void SomeOperations(Ice.Context __context)
	{
	    IceInternal.Outgoing __outS = getOutgoing("SomeOperations", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		if(!__outS.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__outS);
	    }
	}
    }
}

namespace Demo
{
    public sealed class _SimpleDelD : Ice._ObjectDelD, _SimpleDel
    {
	public void SomeOperations(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "SomeOperations", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Simple)
		{
		    try
		    {
			((Demo.Simple)__servant).SomeOperations(__current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}
    }
}

namespace Demo
{
    public abstract class _SimpleDisp : Ice.ObjectImpl, Simple
    {
	#region Slice operations

	public void SomeOperations()
	{
	    SomeOperations(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void SomeOperations(Ice.Current __current);

	#endregion

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::Demo::Simple",
	    "::Ice::Object"
	};

	public override bool ice_isA(string s)
	{
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono)
	    {
		// Mono bug: System.Array.BinarySearch() uses the wrong collation sequence,
		// so we do a linear search for the time being
		int pos = 0;
		while(pos < __ids.Length)
		{
		    if(__ids[pos] == s)
		    {
			break;
		    }
		    ++pos;
		}
		if(pos == __ids.Length)
		{
		    pos = -1;
		}
		return pos >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono)
	    {
		// Mono bug: System.Array.BinarySearch() uses the wrong collation sequence,
		// so we do a linear search for the time being
		int pos = 0;
		while(pos < __ids.Length)
		{
		    if(__ids[pos] == s)
		    {
			break;
		    }
		    ++pos;
		}
		if(pos == __ids.Length)
		{
		    pos = -1;
		}
		return pos >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[0];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[0];
	}

	public static new string ice_staticId()
	{
	    return __ids[0];
	}

	#endregion

	#region Operation dispatch

	public static IceInternal.DispatchStatus ___SomeOperations(Simple __obj, IceInternal.Incoming __inS, Ice.Current __current)
	{
	    __obj.SomeOperations(__current);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	private static string[] __all =
	{
	    "ice_id",
	    "ice_ids",
	    "ice_isA",
	    "ice_ping",
	    "SomeOperations"
	};

	public override IceInternal.DispatchStatus __dispatch(IceInternal.Incoming __inS, Ice.Current __current)
	{
	    int pos;
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono)
	    {
		// Mono bug: System.Array.BinarySearch() uses the wrong collation sequence,
		// so we do a linear search for the time being
		pos = 0;
		while(pos < __all.Length)
		{
		    if(__all[pos] == __current.operation)
		    {
			break;
		    }
		    ++pos;
		}
		if(pos == __all.Length)
		{
		    pos = -1;
		}
	    }
	    else
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation, _System.Collections.Comparer.DefaultInvariant);
	    }
	    if(pos < 0)
	    {
		return IceInternal.DispatchStatus.DispatchOperationNotExist;
	    }

	    switch(pos)
	    {
		case 0:
		{
		    return ___ice_id(this, __inS, __current);
		}
		case 1:
		{
		    return ___ice_ids(this, __inS, __current);
		}
		case 2:
		{
		    return ___ice_isA(this, __inS, __current);
		}
		case 3:
		{
		    return ___ice_ping(this, __inS, __current);
		}
		case 4:
		{
		    return ___SomeOperations(this, __inS, __current);
		}
	    }

	    _System.Diagnostics.Debug.Assert(false);
	    return IceInternal.DispatchStatus.DispatchOperationNotExist;
	}

	#endregion
    }
}

namespace Demo
{
    public class _SimpleTie : _SimpleDisp, Ice.TieBase
    {
	public _SimpleTie()
	{
	}

	public _SimpleTie(_SimpleOperations del)
	{
	    _ice_delegate = del;
	}

	public object ice_delegate()
	{
	    return _ice_delegate;
	}

	public void ice_delegate(object del)
	{
	    _ice_delegate = (_SimpleOperations)del;
	}

	public override int ice_hash()
	{
	    return GetHashCode();
	}

	public override int GetHashCode()
	{
	    return _ice_delegate == null ? 0 : _ice_delegate.GetHashCode();
	}

	public override bool Equals(object rhs)
	{
	    if(object.ReferenceEquals(this, rhs))
	    {
		return true;
	    }
	    if(!(rhs is _SimpleTie))
	    {
		return false;
	    }
	    if(_ice_delegate == null)
	    {
		return ((_SimpleTie)rhs)._ice_delegate == null;
	    }
	    return _ice_delegate.Equals(((_SimpleTie)rhs)._ice_delegate);
	}

	public override void SomeOperations(Ice.Current __current)
	{
	    _ice_delegate.SomeOperations(__current);
	}

	private _SimpleOperations _ice_delegate;
    }
}

namespace IceInternal
{
    namespace SliceChecksums
    {
	public sealed class _74ebf060_2ea1_42e6_8af5_f80ffce23ab6
	{
	    public readonly static System.Collections.Hashtable map = new System.Collections.Hashtable();

	    static _74ebf060_2ea1_42e6_8af5_f80ffce23ab6()
	    {
		map.Add("::Demo::Simple", "86a31ce457bc9cebd9ceb1325d8cdd1");
	    }
	};
    }
}
